<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <title>Visualização D3.js</title>
  <script src="https://d3js.org/d3.v5.min.js"></script>
</head>
<body>
  <div id="tree-container"></div>
  
  <script>
    
    // Função para desenhar a árvore
    //coloca a arvore mais bonita
    function drawTree(data) {
      const width = 928;
      const root = d3.hierarchy(data);
      const dx = 10;
      const dy = width / (root.height + 1);
      const tree = d3.tree().nodeSize([dx, dy]);
      tree(root);

      let x0 = Infinity;
      let x1 = -x0;
      root.each(d => {
        if (d.x > x1) x1 = d.x;
        if (d.x < x0) x0 = d.x;
      });

      const height = x1 - x0 + dx * 2;

      const svg = d3.select("#tree-container").append("svg")
        .attr("width", width)
        .attr("height", height)
        .attr("viewBox", [-dy / 3, x0 - dx, width, height])
        .style("max-width", "100%")
        .style("height", "auto")
        .style("font", "10px sans-serif");

      const link = svg.append("g")
        .attr("fill", "none")
        .attr("stroke", "#555")
        .attr("stroke-opacity", 0.4)
        .attr("stroke-width", 1.5)
        .selectAll("path")
        .data(root.links())
        .join("path")
          .attr("d", d3.linkHorizontal()
              .x(d => d.y)
              .y(d => d.x));

      const node = svg.append("g")
        .attr("stroke-linejoin", "round")
        .attr("stroke-width", 3)
        .selectAll("g")
        .data(root.descendants())
        .join("g")
          .attr("transform", d => `translate(${d.y},${d.x})`);

      node.append("circle")
          .attr("fill", d => d.children ? "#555" : "#999")
          .attr("r", 2.5);

      node.append("text")
          .attr("dy", "0.31em")
          .attr("x", d => d.children ? -6 : 6)
          .attr("text-anchor", d => d.children ? "end" : "start")
          .text(d => d.data.name)
        .clone(true).lower()
          .attr("stroke", "white");
    }
    function loadAndDraw() {
      fetch('/tree_structure_with_counts.json') // Modifique com o caminho correto do seu arquivo JSON
        .then(response => response.json())
        .then(data => {
          drawTree(data);
        })
        .catch(error => console.error('Error loading the JSON file:', error));
    }

    // Chamar a função para iniciar o processo
    loadAndDraw();
  </script>
</body>
</html>
